#######################
# PSXC-IMDB bot-addon #
# -------------------
# Tcl is really not my strong suit, so do not be surprised if your computer
# blows up when you run this script.
#
# This little thingy can be used instead of adding stuff to crontab. It does
# basically the same thing, only this will react instantly on .nfo uploads.
# It may also be used instead of your normal bot config to output stuff in
# (one) channel.
#
# edit the (not so) advanced config below, then copy this script to your bot's
# script directory and add the following to your eggdrop.conf:
#
#   source scripts/psxc-imdb-bot.tcl
#

###################
##### config ######

# location of psxc-imdb.log file (aka IMDBLOG)
set psxc(IMDBLOG)     "/glftpd/ftp-data/logs/psxc-imdb.log"

# location of the imdb-script
set psxc(IMDBSCRIPT)  "/glftpd/bin/psxc-imdb.sh"

# location of psxc-moviedata.log file (aka GLLOG)
# used only in "full" mode, where this addon will do all 
# imdb-output to channel
# !! DO NOT USE glftpd.log HERE !!
set psxc(IMDBMOVIE)   "/glftpd/ftp-data/logs/psxc-moviedata.log"

# announce-channel(s) - separate by space
# used only in "full" mode.
set psxc(IMDBCHANNEL) "#changethis"

# should the lines start with something?
# used only in "full" mode.
set psxc(IMDBTRIG) "\002IMDb:\002"

# location of the .log file used for pre'ing
set psxc(PRELOG)     "/glftpd/ftp-data/logs/glftpd.log"
#set psxc(PRELOG)     "/glftpd/ftp-data/logs/prelog"

# location of the imdb-pre-script. Normally, this is a symlink
# to psxc-imdb.sh.
set psxc(PRESCRIPT)  "/glftpd/bin/psxc-imdb-pre.sh"

# this is where you enable/disable the parts of the script.

# Should the script be used to output imdb-info? Normally
# you set this to "YES"
set psxc(USEBOT)  "YES"

# Should the script handle the imdb-output? Normally dZsbot.tcl
# handles output, but in some cases that doesn't work. This was
# before known as "full" mode.
set psxc(USEFULL) "NO"

# Is pre-support wanted?
set psxc(USEPRE)  "NO"

#
##### config done #####
#######################

proc readimdb {} {
 global psxc psxclog
 utimer 5 "readimdb"
 set psxclogsize [file size $psxc(IMDBLOG)]
 if { $psxclogsize == $psxclog } { return 0 }
 if { $psxclogsize  < $psxclog } { set psxclog 0 }
 set psxcascript $psxc(IMDBSCRIPT)
 set psxcaout [ exec $psxcascript &]
 set psxclog [file size $psxc(IMDBLOG)]
 return 0
}

proc showimdb {} {
 global psxc psxclog psxcmovie
 utimer 5 "showimdb"
 set psxcmoviesize [file size $psxc(IMDBMOVIE)]
 if { $psxcmoviesize == $psxcmovie } { return 0 }
 if { $psxcmoviesize  < $psxcmovie } { set psxcmovie 0 }
 if { [catch { set psxcoffset [open $psxc(IMDBMOVIE) r] } ] } { return 0 }
 seek $psxcoffset $psxcmovie
 while {![eof $psxcoffset]} {
  set psxcline [gets $psxcoffset]
  if {$psxcline == ""} {continue}
  set psxcthr [lindex $psxcline 7]
  foreach psxcimdbchan $psxc(IMDBCHANNEL) { putserv "PRIVMSG $psxcimdbchan :$psxc(IMDBTRIG) $psxcthr" }
 }
 close $psxcoffset
 set psxcmovie [file size $psxc(IMDBMOVIE)]
 return 0
}

proc preimdb {} {
 global psxc psxcprelog
 utimer 5 "preimdb"
 set psxcpresize [file size $psxc(PRELOG)]
 if { $psxcpresize == $psxcprelog } { return 0 }
 if { $psxcpresize  < $psxcprelog } { set psxcprelog 0 }
 set psxccscript $psxc(PRESCRIPT)
 set psxccout [ exec $psxccscript &]
 set psxcprelog [file size $psxc(PRELOG)]
 return 0
}

set psxclog 0
set psxcprelog 0
set psxcmovie [file size $psxc(IMDBMOVIE)]

if { $psxc(USEBOT) == "YES" } { readimdb }
if { $psxc(USEFULL) == "YES" } { showimdb }
if { $psxc(USEPRE) == "YES" } { preimdb }

putlog "Loaded: psxc-imdb bot-addon v2.0a"

